Index: s390-tools-sles11/vmconvert/vm_dump.cpp
===================================================================
--- s390-tools-sles11.orig/vmconvert/vm_dump.cpp
+++ s390-tools-sles11/vmconvert/vm_dump.cpp
@@ -32,19 +32,17 @@ VMDump::getDumpType(const char* inputFil
 	}
 
         /* Record 2: fmbk */
-	if(fseek(fh,0x1000,SEEK_SET) != 0) {
-		fclose(fh);
-		throw DumpErrnoException("Could not seek in vmdump");
-	}
+	dump_seek(fh,0x1000,SEEK_SET);
 	if(fread(&fmbk,sizeof(fmbk),1,fh) != 1) {
-		fclose(fh);
 		if(ferror(fh)) {
 			sprintf(msg,"Could not read header of vmdump '%s'",
 					inputFileName);
+			fclose(fh);
 			throw DumpErrnoException(msg);
 		} else{
 			sprintf(msg,"Input file '%s' is not a vmdump",
 					inputFileName);
+			fclose(fh);
 			throw DumpException(msg);
 		}
 	}
@@ -57,21 +55,18 @@ VMDump::getDumpType(const char* inputFil
 	}
 
 	/* Record 3-7: fir */
-	if(fseek(fh,(fmbk.rec_nr_fir-1)* 0x1000,SEEK_SET) != 0) {
-		fclose(fh);
-		sprintf(msg,"Could not seek in vmdump '%s'",inputFileName);
-		throw DumpErrnoException(msg);
-	}
+	dump_seek(fh,(fmbk.rec_nr_fir-1)* 0x1000,SEEK_SET);
 	if(fread(&fir,sizeof(fir),1,fh) != 1) {
-		fclose(fh);
 		if(ferror(fh)) {
 			sprintf(msg,"Could not read header of vmdump '%s'",
 					inputFileName);
+			fclose(fh);
 			throw DumpErrnoException(msg);
 		}
 		else{
 			sprintf(msg,"Could not read header of vmdump '%s'",
 					inputFileName);
+			fclose(fh);
 			throw DumpException(msg);
 		}
 	}
@@ -95,23 +90,15 @@ VMDump::VMDump(const char *fileName) : D
 
 	/* Record 1: adsrRecord */
 
-	if(fseek(fh,0,SEEK_SET) != 0) {
-		throw(DumpErrnoException("fseek failed"));
-	}
-	if(fread(&adsrRecord,sizeof(adsrRecord),1,fh) != 1) {
-		throw(DumpErrnoException("read failed"));
-	}
+	dump_seek(fh,0,SEEK_SET);
+	dump_read(&adsrRecord,sizeof(adsrRecord),1,fh);
 
 	if(debug) {
 		char buf[1024];
 		int i;
 	
-		if(fseek(fh,adsrRecord.sec3_offset,SEEK_SET) != 0) {
-			throw(DumpErrnoException("fseek failed"));
-		}
-		if(fread(buf,adsrRecord.sec3_len,1,fh) != 1) {
-			throw(DumpErrnoException("read failed"));
-		}
+		dump_seek(fh,adsrRecord.sec3_offset,SEEK_SET);
+		dump_read(buf, adsrRecord.sec3_len,1,fh);
 		ebcAsc(buf,adsrRecord.sec3_len);
 		for(i=0; i < adsrRecord.sec3_len; i++) {
 			if((buf[i]==0) || iscntrl(buf[i]))
@@ -123,12 +110,8 @@ VMDump::VMDump(const char *fileName) : D
 
 	/* Record 2: fmbk */
 
-	if(fseek(fh,0x1000,SEEK_SET) != 0) {
-		throw(DumpErrnoException("fseek failed"));
-	}
-	if(fread(&fmbkRecord,sizeof(fmbkRecord),1,fh) != 1) {
-		throw(DumpErrnoException("read failed"));
-	}
+	dump_seek(fh,0x1000,SEEK_SET);
+	dump_read(&fmbkRecord,sizeof(fmbkRecord),1,fh);
 
 	/* Check if this is a vmdump */
 	if(memcmp(fmbkRecord.id, fmbk_id, 8) != 0) {
@@ -139,13 +122,8 @@ VMDump::VMDump(const char *fileName) : D
 
 	/* Record 8: albk */
 
-	if(fseek(fh,(fmbkRecord.rec_nr_access-1)*0x1000 ,SEEK_SET) != 0) {
-		throw(DumpErrnoException("fseek failed"));
-	}
-	if(fread(&albkRecord,sizeof(albkRecord),1,fh) != 1) {
-		throw(DumpErrnoException("read failed"));
-	}
-
+	dump_seek(fh,(fmbkRecord.rec_nr_access-1)*0x1000 ,SEEK_SET);
+	dump_read(&albkRecord,sizeof(albkRecord),1,fh);
 }
 
 
@@ -216,7 +194,7 @@ VMDump::printInfo(void)
 	struct timeval time;
 	s390TodToTimeval(adsrRecord.tod,&time);
 
-	printf("  date........: %s",ctime(&time.tv_sec));
+	fprintf(stderr, "  date........: %s",ctime(&time.tv_sec));
 }
 
 int
@@ -235,7 +213,7 @@ VMDump::readMem(char* buf, int size)
 	int i;
 
 	if(pageOffset == 0)
-		fseek(fh, memoryStartRecord, SEEK_SET);
+		dump_seek(fh, memoryStartRecord, SEEK_SET);
 
 	if(size % 0x1000 != 0) {
 		throw(DumpException("internal error: VMDump::readMem() "\
@@ -244,8 +222,7 @@ VMDump::readMem(char* buf, int size)
 
 	for(i = 0; i < size; i += 0x1000) {
 		if(testPage(pageOffset)) {
-			if(fread(buf + i, 0x1000,1,fh) != 1)
-				throw(DumpErrnoException("read failed"));
+			dump_read(buf + i, 0x1000,1,fh);
 		} else {
 			memset(buf + i, 0, 0x1000);
 		}
@@ -269,23 +246,14 @@ VMDumpClassic::VMDumpClassic(const char 
 
 	/* Record 9: asibk */
 
-	if(fseek(fh,fmbkRecord.rec_nr_access * 0x1000,SEEK_SET) != 0) {
-		throw(DumpErrnoException("fseek failed"));
-	}
-	if(fread(&asibkRecord,sizeof(asibkRecord),1,fh) != 1) {
-		throw(DumpErrnoException("read failed"));
-	}
+	dump_seek(fh,fmbkRecord.rec_nr_access * 0x1000,SEEK_SET);
+	dump_read(&asibkRecord,sizeof(asibkRecord),1,fh);
 
 	/* Record 10: bitmaps */
 
-	if(fseek(fh,(fmbkRecord.rec_nr_access + 1)* 0x1000 ,SEEK_SET) != 0) { 
-		/* asibkRecord.nr_of_recs_of_first_bit_map XXX ?? */
-		throw(DumpErrnoException("fseek failed"));
-	}
+	dump_seek(fh,(fmbkRecord.rec_nr_access + 1)* 0x1000 ,SEEK_SET);
         bitmap = new char[asibkRecord.storage_size_2GB / (0x1000 * 8)];
-        if(fread(bitmap,asibkRecord.storage_size_2GB / (0x1000*8),1,fh) != 1) {
-		throw(DumpErrnoException("read failed"));
-        }
+	dump_read(bitmap,asibkRecord.storage_size_2GB / (0x1000*8),1,fh);
 
         bitMapPages=asibkRecord.storage_size_2GB / (0x1000 * 8);
         if(bitMapPages % 0x1000 != 0)
@@ -313,7 +281,7 @@ void
 VMDumpClassic::printInfo(void)
 {
 	VMDump::printInfo();
-	printf("  storage.....: %i MB\n",
+	fprintf(stderr, "  storage.....: %i MB\n",
 			asibkRecord.storage_size_2GB/(1024*1024));
 }
 
@@ -335,13 +303,14 @@ VMDump32::VMDump32(const char* filename)
 		return;
 	}
 
-	fseek(fh,(fmbkRecord.rec_nr_fir-1)* 0x1000 ,SEEK_SET);
-	fread(&fir32Record,sizeof(fir32Record),1,fh);
+	dump_seek(fh,(fmbkRecord.rec_nr_fir-1)* 0x1000 ,SEEK_SET);
+	dump_read(&fir32Record,sizeof(fir32Record),1,fh);
 
 	fir32OtherRecords = new _fir_other_32[fir32Record.online_cpus];
 	for(i=0; i < fir32Record.online_cpus; i++) {
 		/* fir other */
-		fread(&fir32OtherRecords[i],sizeof(fir32OtherRecords[i]),1,fh);
+		dump_read(&fir32OtherRecords[i],sizeof(fir32OtherRecords[i]),1,
+			  fh);
 	}
 	if(debug)
 		printDebug();
@@ -407,10 +376,10 @@ VMDump32::printDebug(void)
 void
 VMDump32::printInfo(void)
 {
-	printf("vmdump information:\n");
-	printf("  architecture: 32 bit\n");
+	fprintf(stderr, "vmdump information:\n");
+	fprintf(stderr, "  architecture: 32 bit\n");
 	VMDumpClassic::printInfo();
-	printf("  cpus........: %x\n",fir32Record.online_cpus + 1);
+	fprintf(stderr, "  cpus........: %x\n",fir32Record.online_cpus + 1);
 }
 
 
@@ -432,13 +401,14 @@ VMDump64::VMDump64(const char* filename)
 		return;
 	}
 
-	fseek(fh,(fmbkRecord.rec_nr_fir-1)* 0x1000 ,SEEK_SET);
-	fread(&fir64Record,sizeof(fir64Record),1,fh);
+	dump_seek(fh,(fmbkRecord.rec_nr_fir-1)* 0x1000 ,SEEK_SET);
+	dump_read(&fir64Record,sizeof(fir64Record),1,fh);
 
 	fir64OtherRecords = new _fir_other_64[fir64Record.online_cpus];
 	for(i=0; i < fir64Record.online_cpus; i++) {
 		/* fir other */
-		fread(&fir64OtherRecords[i],sizeof(fir64OtherRecords[i]),1,fh);
+		dump_read(&fir64OtherRecords[i],sizeof(fir64OtherRecords[i]),1,
+			  fh);
 	}
 	if(debug)
 		printDebug();
@@ -463,10 +433,10 @@ VMDump64::printDebug(void)
 void
 VMDump64::printInfo(void)
 {
-	printf("vmdump information:\n");
-	printf("  architecture: 64 bit\n");
+	fprintf(stderr, "vmdump information:\n");
+	fprintf(stderr, "  architecture: 64 bit\n");
 	VMDumpClassic::printInfo();
-	printf("  cpus........: %x\n",fir64Record.online_cpus + 1);
+	fprintf(stderr, "  cpus........: %x\n",fir64Record.online_cpus + 1);
 }
 
 
@@ -532,12 +502,8 @@ VMDump64Big::VMDump64Big(const char* fil
 		
 	/* Record 9: asibk */
 
-	if(fseek(fh,fmbkRecord.rec_nr_access * 0x1000,SEEK_SET) != 0) {
-		throw(DumpErrnoException("fseek failed"));
-	}
-	if(fread(&asibkRecordNew,sizeof(asibkRecordNew),1,fh) != 1) {
-		throw(DumpErrnoException("read failed"));
-	}
+	dump_seek(fh,fmbkRecord.rec_nr_access * 0x1000,SEEK_SET);
+	dump_read(&asibkRecordNew,sizeof(asibkRecordNew),1,fh);
 
 	/* Record 10: bitmaps: */
 	/* Read all bitmap pages and setup bitmap array */
@@ -551,24 +517,16 @@ VMDump64Big::VMDump64Big(const char* fil
 	}
 	memset(bitmap,0,asibkRecordNew.storage_size_def_store/(0x1000 * 8));
 
-	if(fseek(fh,(fmbkRecord.rec_nr_access + 1)* 0x1000 ,SEEK_SET) != 0) { 
-		/* asibkRecord.nr_of_recs_of_first_bit_map XXX ?? */
-		throw(DumpErrnoException("fseek failed"));
-	}
+	dump_seek(fh,(fmbkRecord.rec_nr_access + 1)* 0x1000 ,SEEK_SET);
 
 	do {
 		char bmIndexPage[0x1000];
-		if(fread(bmIndexPage,sizeof(bmIndexPage),1,fh) != 1) {
-			throw(DumpErrnoException("read failed"));
-		}
+		dump_read(bmIndexPage,sizeof(bmIndexPage),1,fh);
 		memoryStartRecord += 0x1000;
 		for(i=0; i < 0x1000; i++) {
 			if(testBitmapPage(bmIndexPage,i)) {
 				char bmPage[0x1000];
-				if(fread(bmPage,sizeof(bmPage),1,fh) != 1) {
-					throw(DumpErrnoException("read "\
-								"failed"));
-				}
+				dump_read(bmPage,sizeof(bmPage),1,fh);
 				memoryStartRecord += 0x1000;
 				for(j = 0; j < 0x1000; j++) {
 					if(testBitmapKeyPage(bmPage, j)) {
@@ -590,13 +548,14 @@ all_bitmaps_read:
 	if(debug)
 		printf("Mem Offset: %llx\n",(long long)memoryStartRecord);
 
-	fseek(fh,(fmbkRecord.rec_nr_fir-1)* 0x1000 ,SEEK_SET);
-	fread(&fir64Record,sizeof(fir64Record),1,fh);
+	dump_seek(fh,(fmbkRecord.rec_nr_fir-1)* 0x1000 ,SEEK_SET);
+	dump_read(&fir64Record,sizeof(fir64Record),1,fh);
 
 	fir64OtherRecords = new _fir_other_64[fir64Record.online_cpus];
 	for(i=0; i < fir64Record.online_cpus; i++) {
 		/* fir other */
-		fread(&fir64OtherRecords[i],sizeof(fir64OtherRecords[i]),1,fh);
+		dump_read(&fir64OtherRecords[i],sizeof(fir64OtherRecords[i]),1,
+			  fh);
 	}
 	if(debug)
 		printDebug();
@@ -621,12 +580,12 @@ VMDump64Big::printDebug(void)
 void
 VMDump64Big::printInfo(void)
 {
-	printf("vmdump information:\n");
-	printf("  architecture: 64 bit (big)\n");
-	printf("  storage.....: %lli MB\n",
+	fprintf(stderr, "vmdump information:\n");
+	fprintf(stderr, "  architecture: 64 bit (big)\n");
+	fprintf(stderr, "  storage.....: %lli MB\n",
 		(long long)asibkRecordNew.storage_size_def_store / (1024*1024));
 	VMDump::printInfo();
-	printf("  cpus........: %x\n",fir64Record.online_cpus + 1);
+	fprintf(stderr, "  cpus........: %x\n",fir64Record.online_cpus + 1);
 }
 
 
Index: s390-tools-sles11/vmur/Makefile
===================================================================
--- s390-tools-sles11.orig/vmur/Makefile
+++ s390-tools-sles11/vmur/Makefile
@@ -1,12 +1,25 @@
 # Common definitions
 include ../common.mak
 
-CFLAGS        += -D_FILE_OFFSET_BITS=64 -I../include -L.
+CXXFLAGS      += -c -D_FILE_OFFSET_BITS=64 -I../include -I../vmconvert
+VMCONVERT_SRC	= ../vmconvert/convert.cpp ../vmconvert/lkcd_dump.cpp \
+		  ../vmconvert/vm_dump.cpp ../vmconvert/register_content.cpp \
+		  ../vmconvert/dump.cpp ../vmconvert/dump.h \
+		  ../vmconvert/lkcd_dump.h ../vmconvert/register_content.h \
+		  ../vmconvert/vm_dump.h
+VMCONVERT_OBJS	= ../vmconvert/convert.o ../vmconvert/lkcd_dump.o \
+		  ../vmconvert/vm_dump.o ../vmconvert/register_content.o \
+		  ../vmconvert/dump.o
+
+OBJS          = vmur.o $(VMCONVERT_OBJS)
 
 all: vmur
 
-vmur: vmur.c vmur.h
-	$(CC) $(CFLAGS) -o $@ vmur.c
+vmur.o: vmur.cpp vmur.h $(VMCONVERT_SRC)
+	$(CXX) $(CXXFLAGS) vmur.cpp
+
+vmur: $(OBJS)
+	$(CXX) -o vmur $(OBJS) -lz
 
 install: all
 	$(INSTALL) -d -m 755 $(BINDIR) $(MANDIR)/man8
